import 'package:flutter_test/flutter_test.dart';

import 'package:recursion_iterator/recursion_iterator.dart';

void main() {
  test('test recursion iterator', () {
    final iterable = RecursionIterable<int>(() {
      int index = 0;
      return RecursionIterator((iter) {
        if (index < 3) {
          int i = ++index;
          bool runOver = false;
          return iter.iterator(RecursionIterator((iter) {
            if (runOver) {
              return iter.stop;
            } else {
              runOver = true;
              return iter.iterable([1 * i, 2 * i, 3 * i]);
            }
          }));
        } else {
          return iter.stop;
        }
      });
    });
    expect(iterable.toList(),[1,2,3,2,4,6,3,6,9]);
  });
}
